version: '3.7'
services:

  redis:
    image: 'redis:7.4.0-alpine3.20'
    user: '999:1000'
    read_only: true
    volumes:
      - type: 'tmpfs'
        target: '/tmp'
      - type: 'volume'
        target: '/data'
    restart: 'unless-stopped'

  postgres:
    image: 'postgres:16.4-alpine3.20'
    user: '70:70'
    read_only: true
    environment:
      POSTGRES_PASSWORD: 'password'
    volumes:
      - type: 'tmpfs'
        target: '/tmp'
      - type: 'tmpfs'
        target: '/run/postgresql'
      - type: 'volume'
        source: 'postgresql_datadir'
        target: '/var/lib/postgresql/data'
      - type: 'volume'
        source: 'postgresql_initdb_dir'
        target: '/docker-entrypoint-initdb.d'
        read_only: true
    restart: 'unless-stopped'

  nginx:
    image: 'nginx:1.27.1-alpine3.20'
    ports:
      - '8000:80'
    volumes:
      - type: 'tmpfs'
        target: '/tmp'
      - type: 'tmpfs'
        target: '/run'
      - type: 'tmpfs'
        target: '/var/cache/nginx'
      - type: 'volume'
        source: 'nginx_conf_dir'
        target: '/etc/nginx/conf.d'
        read_only: true
      - type: 'volume'
        source: 'indico_home_dir'
        target: '/opt/indico'
        read_only: true
    restart: 'unless-stopped'

  celery:
    build:
      context: .
      args:
        INDICO_VERSION: '${INDICO_VERSION:-3.3.4}'
    image: '$INDICO_IMAGE_NAME'
    user: '999:101'
    read_only: true
    environment:
      SECRET_KEY: 'a super secret key here'
      SQLALCHEMY_DATABASE_URI: 'postgresql://postgres:password@postgres/postgres'
      BASE_URL: 'http://localhost:8000'
      CELERY_BROKER: 'redis://redis:6379/0'
      REDIS_CACHE_URL: 'redis://redis:6379/1'
      SUPPORT_EMAIL: 'info@email.space'
      PUBLIC_SUPPORT_EMAIL: 'info@email.space'
      NO_REPLY_EMAIL: 'noreply@email.space'
      STATIC_FILE_METHOD: "('xaccelredirect', {'/opt/indico': '/.xsf/indico'})"
      XELATEX_PATH: 'xelatex'
      USE_PROXY: 'True'
    command: ["celery"]
    volumes:
      - type: 'tmpfs'
        target: '/tmp'
      - type: 'volume'
        source: 'indico_home_dir'
        target: '/opt/indico'
      - type: 'volume'
        source: 'indico_config_dir'
        target: '/opt/indico/etc'
    restart: 'unless-stopped'

  indico:
    build:
      context: .
      args:
        INDICO_VERSION: '${INDICO_VERSION:-3.3.4}'
    image: '$INDICO_IMAGE_NAME'
    user: '999:101'
    read_only: true
    environment:
      SECRET_KEY: 'a super secret key here'
      SQLALCHEMY_DATABASE_URI: 'postgresql://postgres:password@postgres/postgres'
      BASE_URL: 'http://localhost:8000'
      CELERY_BROKER: 'redis://redis:6379/0'
      REDIS_CACHE_URL: 'redis://redis:6379/1'
      SUPPORT_EMAIL: 'info@email.space'
      PUBLIC_SUPPORT_EMAIL: 'info@email.space'
      NO_REPLY_EMAIL: 'noreply@email.space'
      STATIC_FILE_METHOD: "('xaccelredirect', {'/opt/indico': '/.xsf/indico'})"
      XELATEX_PATH: 'xelatex'
      USE_PROXY: 'True'
    volumes:
      - type: 'tmpfs'
        target: '/tmp'
      - type: 'volume'
        source: 'indico_home_dir'
        target: '/opt/indico'
      - type: 'volume'
        source: 'indico_config_dir'
        target: '/opt/indico/etc'
    restart: 'unless-stopped'

volumes:
  indico_home_dir:
  indico_config_dir:
  postgresql_datadir:
  postgresql_initdb_dir:
    driver: local
    driver_opts:
      type: 'none'
      o: 'bind'
      device: '${PWD}/volumes/postgres/docker-entrypoint-initdb.d'
  nginx_conf_dir:
    driver: local
    driver_opts:
      type: 'none'
      o: 'bind'
      device: '${PWD}/volumes/nginx/etc/nginx/conf.d'
